"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const node_fs_1 = __importDefault(require("node:fs"));
const node_path_1 = __importDefault(require("node:path"));
const rimraf = __importStar(require("rimraf"));
const _1 = require("./");
test("compare with 2 png files", () => __awaiter(void 0, void 0, void 0, function* () {
    const diffFilename = node_path_1.default.resolve(__dirname, "../test-images/diff_generated.png");
    rimraf.sync(diffFilename);
    yield (0, _1.imgDiff)({
        actualFilename: node_path_1.default.resolve(__dirname, "../test-images/actual.png"),
        expectedFilename: node_path_1.default.resolve(__dirname, "../test-images/expected.png"),
    });
    expect(() => node_fs_1.default.statSync(node_path_1.default.resolve(__dirname, "../test-images/diff_generated.png"))).toThrowError();
    const { imagesAreSame } = yield (0, _1.imgDiff)({
        diffFilename,
        actualFilename: node_path_1.default.resolve(__dirname, "../test-images/actual.png"),
        expectedFilename: node_path_1.default.resolve(__dirname, "../test-images/expected.png"),
    });
    expect(imagesAreSame).toBe(false);
    expect(node_fs_1.default.statSync(node_path_1.default.resolve(__dirname, "../test-images/diff_generated.png"))).toBeTruthy();
}));
test("compare with 2 same files", () => __awaiter(void 0, void 0, void 0, function* () {
    const { imagesAreSame } = yield (0, _1.imgDiff)({
        actualFilename: node_path_1.default.resolve(__dirname, "../test-images/expected.png"),
        expectedFilename: node_path_1.default.resolve(__dirname, "../test-images/expected.png"),
    });
    expect(imagesAreSame).toBe(true);
}));
test("compare with 2 files whose dimension are different", () => __awaiter(void 0, void 0, void 0, function* () {
    const diffFilename = node_path_1.default.resolve(__dirname, "../test-images/diff_generated.wide.png");
    rimraf.sync(diffFilename);
    yield (0, _1.imgDiff)({
        diffFilename,
        actualFilename: node_path_1.default.resolve(__dirname, "../test-images/actual_wide.png"),
        expectedFilename: node_path_1.default.resolve(__dirname, "../test-images/expected.png"),
    });
    expect(node_fs_1.default.statSync(node_path_1.default.resolve(__dirname, "../test-images/diff_generated.wide.png"))).toBeTruthy();
}));
test("compare with 2 jpeg files", () => __awaiter(void 0, void 0, void 0, function* () {
    const diffFilename = node_path_1.default.resolve(__dirname, "../test-images/diff_generated.tiff.png");
    rimraf.sync(diffFilename);
    yield (0, _1.imgDiff)({
        diffFilename,
        actualFilename: node_path_1.default.resolve(__dirname, "../test-images/actual.tiff"),
        expectedFilename: node_path_1.default.resolve(__dirname, "../test-images/expected.tiff"),
    });
    expect(node_fs_1.default.statSync(node_path_1.default.resolve(__dirname, "../test-images/diff_generated.tiff.png"))).toBeTruthy();
}));
test("compare with 2 jpeg files", () => __awaiter(void 0, void 0, void 0, function* () {
    const diffFilename = node_path_1.default.resolve(__dirname, "../test-images/diff_generated.jpg.png");
    rimraf.sync(diffFilename);
    yield (0, _1.imgDiff)({
        diffFilename,
        actualFilename: node_path_1.default.resolve(__dirname, "../test-images/actual.jpg"),
        expectedFilename: node_path_1.default.resolve(__dirname, "../test-images/expected.jpg"),
    });
    expect(node_fs_1.default.statSync(node_path_1.default.resolve(__dirname, "../test-images/diff_generated.jpg.png"))).toBeTruthy();
}));
describe("threshold pattern", () => {
    test("no option object", () => __awaiter(void 0, void 0, void 0, function* () {
        const result = yield (0, _1.imgDiff)({
            actualFilename: node_path_1.default.resolve(__dirname, "../test-images/actual.png"),
            expectedFilename: node_path_1.default.resolve(__dirname, "../test-images/expected.png"),
        });
        expect(result.imagesAreSame).toBeFalsy();
    }));
    test("threshold is undefined", () => __awaiter(void 0, void 0, void 0, function* () {
        const result = yield (0, _1.imgDiff)({
            actualFilename: node_path_1.default.resolve(__dirname, "../test-images/actual.png"),
            expectedFilename: node_path_1.default.resolve(__dirname, "../test-images/expected.png"),
            options: {},
        });
        expect(result.imagesAreSame).toBeFalsy();
    }));
    test("set threshold explicitly", () => __awaiter(void 0, void 0, void 0, function* () {
        const result = yield (0, _1.imgDiff)({
            actualFilename: node_path_1.default.resolve(__dirname, "../test-images/actual.png"),
            expectedFilename: node_path_1.default.resolve(__dirname, "../test-images/expected.png"),
            options: {
                threshold: 1.0,
            },
        });
        expect(result.imagesAreSame).toBeTruthy();
    }));
});
//# sourceMappingURL=index.test.js.map